Index: i18n/uk.ts
===================================================================
--- i18n/uk.ts	(revision 5a81a64d743c8148a351676a7afbd248b0d50c40)
+++ i18n/uk.ts	(revision f0464480dbaed4452bd34ee92f4a2e0b8d6de557)
@@ -32,26 +32,26 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="152"/>
-        <location filename="../src/tspmodel.cpp" line="160"/>
-        <location filename="../src/tspmodel.cpp" line="181"/>
-        <location filename="../src/tspmodel.cpp" line="201"/>
-        <location filename="../src/tspmodel.cpp" line="214"/>
-        <location filename="../src/tspmodel.cpp" line="247"/>
-        <location filename="../src/tspmodel.cpp" line="256"/>
+        <location filename="../src/tspmodel.cpp" line="153"/>
+        <location filename="../src/tspmodel.cpp" line="163"/>
+        <location filename="../src/tspmodel.cpp" line="187"/>
+        <location filename="../src/tspmodel.cpp" line="208"/>
+        <location filename="../src/tspmodel.cpp" line="222"/>
+        <location filename="../src/tspmodel.cpp" line="257"/>
+        <location filename="../src/tspmodel.cpp" line="267"/>
         <source>Task Load</source>
         <translation>Завантаження умови</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="152"/>
-        <location filename="../src/tspmodel.cpp" line="181"/>
-        <location filename="../src/tspmodel.cpp" line="201"/>
-        <location filename="../src/tspmodel.cpp" line="214"/>
-        <location filename="../src/tspmodel.cpp" line="247"/>
-        <location filename="../src/tspmodel.cpp" line="256"/>
+        <location filename="../src/tspmodel.cpp" line="153"/>
+        <location filename="../src/tspmodel.cpp" line="187"/>
+        <location filename="../src/tspmodel.cpp" line="208"/>
+        <location filename="../src/tspmodel.cpp" line="222"/>
+        <location filename="../src/tspmodel.cpp" line="257"/>
+        <location filename="../src/tspmodel.cpp" line="267"/>
         <source>Unable to load task:</source>
         <translation>Неможливо завантажити умову:</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="160"/>
+        <location filename="../src/tspmodel.cpp" line="163"/>
         <source>Unable to open task file.
 Error: %1</source>
@@ -60,11 +60,11 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="181"/>
+        <location filename="../src/tspmodel.cpp" line="187"/>
         <source>Unknown file format or file is corrupted.</source>
         <translation>Невідомий формат файлу або файл пошкоджено.</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="201"/>
-        <location filename="../src/tspmodel.cpp" line="247"/>
+        <location filename="../src/tspmodel.cpp" line="208"/>
+        <location filename="../src/tspmodel.cpp" line="257"/>
         <source>File version is newer than application supports.
 Please, try to update application.</source>
@@ -73,6 +73,6 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="214"/>
-        <location filename="../src/tspmodel.cpp" line="256"/>
+        <location filename="../src/tspmodel.cpp" line="222"/>
+        <location filename="../src/tspmodel.cpp" line="267"/>
         <source>Unexpected data read.
 File is possibly corrupted.</source>
@@ -81,17 +81,17 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="289"/>
-        <location filename="../src/tspmodel.cpp" line="295"/>
-        <location filename="../src/tspmodel.cpp" line="302"/>
-        <location filename="../src/tspmodel.cpp" line="309"/>
-        <location filename="../src/tspmodel.cpp" line="316"/>
-        <location filename="../src/tspmodel.cpp" line="323"/>
-        <location filename="../src/tspmodel.cpp" line="330"/>
-        <location filename="../src/tspmodel.cpp" line="340"/>
+        <location filename="../src/tspmodel.cpp" line="303"/>
+        <location filename="../src/tspmodel.cpp" line="311"/>
+        <location filename="../src/tspmodel.cpp" line="319"/>
+        <location filename="../src/tspmodel.cpp" line="327"/>
+        <location filename="../src/tspmodel.cpp" line="335"/>
+        <location filename="../src/tspmodel.cpp" line="343"/>
+        <location filename="../src/tspmodel.cpp" line="351"/>
+        <location filename="../src/tspmodel.cpp" line="362"/>
         <source>Task Save</source>
         <translation>Збереження умови</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="289"/>
+        <location filename="../src/tspmodel.cpp" line="303"/>
         <source>Unable to create task file.
 Error: %1
@@ -102,11 +102,11 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="295"/>
-        <location filename="../src/tspmodel.cpp" line="302"/>
-        <location filename="../src/tspmodel.cpp" line="309"/>
-        <location filename="../src/tspmodel.cpp" line="316"/>
-        <location filename="../src/tspmodel.cpp" line="323"/>
-        <location filename="../src/tspmodel.cpp" line="330"/>
-        <location filename="../src/tspmodel.cpp" line="340"/>
+        <location filename="../src/tspmodel.cpp" line="311"/>
+        <location filename="../src/tspmodel.cpp" line="319"/>
+        <location filename="../src/tspmodel.cpp" line="327"/>
+        <location filename="../src/tspmodel.cpp" line="335"/>
+        <location filename="../src/tspmodel.cpp" line="343"/>
+        <location filename="../src/tspmodel.cpp" line="351"/>
+        <location filename="../src/tspmodel.cpp" line="362"/>
         <source>Unable to save task.
 Error: %1</source>
@@ -133,10 +133,10 @@
     </message>
     <message>
-        <location filename="../src/tspsolver.cpp" line="209"/>
+        <location filename="../src/tspsolver.cpp" line="217"/>
         <source>Solution Result</source>
         <translation>Результат розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../src/tspsolver.cpp" line="209"/>
+        <location filename="../src/tspsolver.cpp" line="217"/>
         <source>Unable to find solution.
 Maybe, this task has no solutions.</source>
@@ -144,4 +144,11 @@
 Можливо, у задачі немає розв&apos;зку.</translation>
     </message>
+    <message>
+        <location filename="../src/tspsolver.cpp" line="235"/>
+        <location filename="../src/tspsolver.cpp" line="237"/>
+        <location filename="../src/tspsolver.cpp" line="240"/>
+        <source>City %1</source>
+        <translation>Місто %1</translation>
+    </message>
 </context>
 <context>
@@ -521,6 +528,6 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="551"/>
-        <location filename="../src/mainwindow.cpp" line="560"/>
+        <location filename="../src/mainwindow.cpp" line="546"/>
+        <location filename="../src/mainwindow.cpp" line="555"/>
         <source>Language change</source>
         <translation>Зміна мови</translation>
@@ -549,6 +556,6 @@
     <message>
         <location filename="../src/mainwindow.cpp" line="237"/>
-        <location filename="../src/mainwindow.cpp" line="293"/>
-        <location filename="../src/mainwindow.cpp" line="337"/>
+        <location filename="../src/mainwindow.cpp" line="286"/>
+        <location filename="../src/mainwindow.cpp" line="330"/>
         <source>All Files</source>
         <translation>Усі файли</translation>
@@ -571,30 +578,30 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="287"/>
+        <location filename="../src/mainwindow.cpp" line="280"/>
         <source>PDF Files</source>
         <translation>Файлы PDF</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="289"/>
+        <location filename="../src/mainwindow.cpp" line="282"/>
         <source>HTML Files</source>
         <translation>Файли HTML</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="291"/>
+        <location filename="../src/mainwindow.cpp" line="284"/>
         <source>OpenDocument Files</source>
         <translation>Файли OpenDocument</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="336"/>
+        <location filename="../src/mainwindow.cpp" line="329"/>
         <source>%1 Task File</source>
         <translation>Файл умови %1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="367"/>
+        <location filename="../src/mainwindow.cpp" line="357"/>
         <source>Settings Changed</source>
         <translation>Параметри змінено</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="367"/>
+        <location filename="../src/mainwindow.cpp" line="357"/>
         <source>You have changed color settings.
 Do you wish to apply them to current solution text?</source>
@@ -603,56 +610,66 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="449"/>
+        <location filename="../src/mainwindow.cpp" line="439"/>
         <source>Data error</source>
         <translation>Помилка у даних</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="449"/>
+        <location filename="../src/mainwindow.cpp" line="439"/>
         <source>Error in cell [Row %1; Column %2]: Invalid data format.</source>
         <translation>Помилка у комірці  [Рядок %1; Колонка %2]: Невірний формат даних.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="462"/>
+        <location filename="../src/mainwindow.cpp" line="452"/>
         <source>Variant #%1</source>
         <translation>Варіант №%1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="463"/>
+        <location filename="../src/mainwindow.cpp" line="453"/>
         <source>Task:</source>
         <translation>Умова:</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="466"/>
-        <location filename="../src/mainwindow.cpp" line="492"/>
+        <location filename="../src/mainwindow.cpp" line="456"/>
+        <location filename="../src/mainwindow.cpp" line="487"/>
         <source>Solution of Variant #%1 task</source>
         <translation>Розв&apos;язок варіанту №%1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="473"/>
+        <location filename="../src/mainwindow.cpp" line="462"/>
         <source>Step #%1</source>
         <translation>Крок №%1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="476"/>
+        <location filename="../src/mainwindow.cpp" line="465"/>
         <source>This step has alternate candidates for branching.</source>
         <translation>У цьому кроці є альтернативні кандидати на розгалудження.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="488"/>
+        <location filename="../src/mainwindow.cpp" line="477"/>
         <source>Optimal path:</source>
         <translation>Оптимальний шлях:</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="490"/>
+        <location filename="../src/mainwindow.cpp" line="479"/>
+        <source>Resulting path:</source>
+        <translation>Знайдений шлях:</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="481"/>
         <source>The price is &lt;b&gt;%1&lt;/b&gt; units.</source>
         <translation>Вартість - &lt;b&gt;%1&lt;/b&gt; одиниць.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="551"/>
+        <location filename="../src/mainwindow.cpp" line="484"/>
+        <source>&lt;b&gt;WARNING!!!&lt;/b&gt;&lt;br&gt;This result is a record, but it may not be optimal.&lt;br&gt;Iterations need to be continued to check whether this result is optimal or get an optimal one.</source>
+        <translation>Увага!!!&lt;br&gt;Знайдений розв&apos;язок є рекордом, але може бути неоптимальним.&lt;br&gt;Для отримання оптимального розв&apos;зку, або перевірки поточного на оптимальність, потрібно продовжити ітерації.</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="546"/>
         <source>Language will be autodetected on next application start.</source>
         <translation>Мову буде автоматично визначено при наступному запуску додатку.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="560"/>
+        <location filename="../src/mainwindow.cpp" line="555"/>
         <source>You have language autodetection turned on.
 It needs to be off.
@@ -663,7 +680,7 @@
     </message>
     <message>
+        <location filename="../src/mainwindow.cpp" line="255"/>
+        <location filename="../src/mainwindow.cpp" line="560"/>
         <location filename="../src/mainwindow.h" line="79"/>
-        <location filename="../src/mainwindow.cpp" line="259"/>
-        <location filename="../src/mainwindow.cpp" line="565"/>
         <source>Untitled</source>
         <translation>Без імені</translation>
@@ -683,101 +700,101 @@
     </message>
     <message>
-        <location filename="../src/settingsdialog.cpp" line="101"/>
+        <location filename="../src/settingsdialog.cpp" line="103"/>
         <source>Hover mouse pointer over dialog elements to get additional help</source>
         <translation>Наведіть покажчик миші на елемент ділогу, щоб отримати підказку</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="14"/>
+        <location filename="../ui/settingsdialog.ui" line="6"/>
         <source>Preferences</source>
         <translation>Параметри</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="268"/>
+        <location filename="../ui/settingsdialog.ui" line="177"/>
         <source>Random values:</source>
         <translation>Випадкові значення:</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="276"/>
+        <location filename="../ui/settingsdialog.ui" line="185"/>
         <source>&amp;Minimal:</source>
         <translation>&amp;Мінімум:</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="295"/>
+        <location filename="../ui/settingsdialog.ui" line="204"/>
         <source>Minimum for random number generation</source>
         <translation>Нажня межа для генерації випадкових значень</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="306"/>
+        <location filename="../ui/settingsdialog.ui" line="215"/>
         <source>Ma&amp;ximal:</source>
         <translation>М&amp;аксимум:</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="325"/>
+        <location filename="../ui/settingsdialog.ui" line="234"/>
         <source>Maximum for random number generation</source>
         <translation>Верхня межа для генерації випадкових значень</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="343"/>
+        <location filename="../ui/settingsdialog.ui" line="244"/>
         <source>Output settings:</source>
         <translation>Параметри виводу:</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="381"/>
+        <location filename="../ui/settingsdialog.ui" line="266"/>
         <source>Font color for printing</source>
         <translation>Колір шрифта для друку</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="384"/>
+        <location filename="../ui/settingsdialog.ui" line="269"/>
         <source>&amp;Color...</source>
         <translation>&amp;Колір...</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="394"/>
+        <location filename="../ui/settingsdialog.ui" line="282"/>
         <source>Automatically resize rows and columns to their contents</source>
         <translation>Автоматично підганяти розмір рядків під їх зміст</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="397"/>
+        <location filename="../ui/settingsdialog.ui" line="285"/>
         <source>Autosize of rows and columns</source>
         <translation>Авторозмір рядків та колонок</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="358"/>
+        <location filename="../ui/settingsdialog.ui" line="251"/>
         <source>Font face for printing</source>
         <translation>Вигляд шрифта для друку</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="361"/>
+        <location filename="../ui/settingsdialog.ui" line="254"/>
         <source>&amp;Font...</source>
         <translation>&amp;Шрифт...</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="165"/>
-        <location filename="../ui/settingsdialog.ui" line="171"/>
+        <location filename="../ui/settingsdialog.ui" line="117"/>
+        <location filename="../ui/settingsdialog.ui" line="123"/>
         <source>Help</source>
         <translation>Допомога</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="168"/>
+        <location filename="../ui/settingsdialog.ui" line="120"/>
         <source>Get preferences help</source>
         <translation>Отримати допомогу по налагодженням</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="136"/>
+        <location filename="../ui/settingsdialog.ui" line="96"/>
         <source>Save new preferences</source>
         <translation>Зберегти нові параметри</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="139"/>
+        <location filename="../ui/settingsdialog.ui" line="99"/>
         <source>&amp;OK</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="113"/>
+        <location filename="../ui/settingsdialog.ui" line="81"/>
         <source>Close without saving preferences</source>
         <translation>Закрити вікно без збереження параметрів</translation>
     </message>
     <message>
-        <location filename="../ui/settingsdialog.ui" line="116"/>
+        <location filename="../ui/settingsdialog.ui" line="84"/>
         <source>&amp;Cancel</source>
         <translation>&amp;Скасувати</translation>
